<?php

////////////////////////////////ATENÇÃO\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/********************************************************************************
*    CONTROLLER PARA A FUNÇÃO RECALCULO DE SALDOS PARA DÉBITO PESSOAL           * 
*   PARA CRÉDITO PESSOAL: Teknisa\MAN\Controllers\RecalculoSaldoConCredito      *
********************************************************************************/
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services\RecalculoSaldoConsDebService;

class RecalculoSaldoConsDeb extends  \Teknisa\MAN\Controllers\TeknisaCrud{


    const dataSourceTipoCons      = 'vnd02800_recalculosaldocons_tipoCons',
          dataSourceConsumidor    = 'vnd02800_recalculosaldocons_Consumidor',
          dataSourceCliente       = 'vnd02800_recalculosaldocons_Cliente';

    protected $parameterBagColumnsTipoCons        = array('NRORG', 'CDCLIENTE'),
              $parameterBagColumnsConsumidor      = array('NRORG','CDCLIENTE'),
              $parameterBagColumnsCliente         = array('NRORG', 'P_CDFILIAL'),
              $utilService;
    
    public function __construct ($crudService, $parameterBag, $entityManager, Utilities\Util $utilService, Manager $dataSourceManager, RecalculoSaldoConsDebService $RecalculoSaldoConsDebService) {
        $this->crudService                  = $crudService;
        $this->parameterBag                 = $parameterBag;
        $this->entityManager                = $entityManager;
        $this->utilService                  = $utilService;
        $this->dataSourceManager            = $dataSourceManager;
        $this->RecalculoSaldoConsDebService = $RecalculoSaldoConsDebService;
    }
    
    public function findTipoCons(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = self::dataSourceTipoCons;
        $this->parameterBagColumns = $this->parameterBagColumnsTipoCons;
        parent::find($request, $response);
    }
    
    public function findConsumidor(DTO\Request\Filter $request, DTO\Response $response){
        $conditions = $this->utilService->getParamsAsArray($request);
        /*Se o array conditions tiver somente duas posições o dataSourceFilter enviado não possui CDTIPOCONS, sendo assim a query a ser executada
        levará em conta todos os CDTIPOCONS possiveis para os CDCLIENTE selecionados, e depois retornará todos os Consumidores desses CDTIPOCONS,
        mas se o array conditions tiver mais posições, o CDTIPOCONS foi selecionado e enviado pelo dataSourceFilter, assim os Consumidores selecionados
        devem ser aqueles que pertencem aos CDTIPOCONS que foram enviados*/
        $array_Conditions = array_keys($conditions);
        if(!array_search('CDTIPOCONS', $array_Conditions)){
            
            $this->dataSourceName = 'vnd02800_recalculosaldocons_Consumidor';
            $dataSourceFilter = array();
            $dataSourceFilter[0] = array(
                "columnName" => 'P_CDFILIAL',
                "operator"   => "=",
                "value"      => $conditions['CDFILIAL']
            ); 
            foreach($conditions as $key => $value) {
                $dataSourceFilter[1] = array(
                    "columnName" => 'P_CDCLIENTE',
                    "operator"   => "=",
                    "value"      => $value = (join("_", $conditions['CDCLIENTE']))
                );
            }
            $dataSourceFilter[2] = array(
                "columnName" => 'P_TCDTIPOCONS',
                "operator"   => "=",
                "value"      => 'T'
            );
            $dataSourceFilter[3] = array(
                "columnName" => 'P_CDTIPOCONS',
                "operator"   => "=",
                "value"      => null
            );
            $dataSourceFilter[4] = array(
                "columnName" => 'P_TCDCLIENTE',
                "operator"   => "=",
                "value"      => null
            );
            for($i = 2 ; $i < sizeof($array_Conditions); $i++) {
                array_push($dataSourceFilter, array(
                    "columnName" => $array_Conditions[$i],
                    "operator"   => "LIKE_I",
                    "value"      => $conditions[$array_Conditions[$i]]
            ));
            }
            $newRequest = new DTO\Request\Filter(
                new FilterCriteria(
                    $request->getFilterCriteria()->getDataSourceName(),
                    $dataSourceFilter,
                    $request->getFilterCriteria()->getPage(),
                    $request->getFilterCriteria()->getPageSize()
                ),
                $request->getMethod(),
                $request->getRoutePath(),
                $request->getUserId()
            );
            $this->parameterBagColumns = array('P_CDFILIAL','P_CDCLIENTE', 'P_TCDTIPOCONS', 'P_CDTIPOCONS', 'P_TCDCLIENTE');
        	parent::find($newRequest, $response);
        	
        } else {
            $dataSourceName = $this->dataSourceName = 'vnd02800_recalculosaldocons_tCConsumidor';
            $routePath = $this->routePath = 'vnd02800_recalculosaldocons_tCConsumidor';
            $dataSourceFilter = array();
            $dataSourceFilter[0] = array(
                "columnName" => 'NRORG',
                "operator"   => "=",
                "value"      => $conditions['NRORG']
            ); 
            foreach($conditions as $key => $value) {
                $dataSourceFilter[1] = array(
                    "columnName" => 'CDCLIENTE',
                    "operator"   => "IN",
                    "value"      => $value = (join("_", $conditions['CDCLIENTE']))
                );
                $dataSourceFilter[2] = array(
                    "columnName" => 'CDTIPOCONS',
                    "operator"   => "IN",
                    "value"      => $value = (join("_", $conditions['CDTIPOCONS']))
                );
            }
            for($i = 3; $i < sizeof($array_Conditions); $i++) {
                array_push($dataSourceFilter, array(
                    "columnName" => $array_Conditions[$i],
                    "operator"   => "LIKE_I",
                    "value"      => $conditions[$array_Conditions[$i]]
                ));
            }
            $newRequest = new DTO\Request\Filter(
                new FilterCriteria(
                    $dataSourceName,
                    $dataSourceFilter,
                    $request->getFilterCriteria()->getPage(),
                    $request->getFilterCriteria()->getPageSize()
                ),
                $request->getMethod(),
                $routePath,
                $request->getUserId()
           );
            RecalculoSaldoConsDeb::findTipoConsConsumidor($newRequest, $response);
        }
        
    }    
        
    public function findTipoConsConsumidor($newRequest, $response){
        $this->parameterBagColumns = array('NRORG','CDCLIENTE', 'CDTIPOCONS');
        parent::find($newRequest,$response);
    }
    
    public function findCliente(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = self::dataSourceCliente;
        $this->parameterBagColumns = $this->parameterBagColumnsCliente;
        parent::find($request,$response);
    }
    
    public function queryConsumidor(DTO\Request\Row $request, DTO\Response $response){
        $params = $request->getRow();
        /*Se o CDCLIENTE não foi enviado na currentRow, todos os dados devem ser coletados a partir da query
        passando T(todos) em todos os paramêtros*/
        if(!isset($params['CDCLIENTE'])){
            $parameters = array(
    			'P_CDCLIENTE' => null,
    			'P_TCDCLIENTE' => 'T',
    			'P_CDCONSUMIDOR'=> null,
    			'P_TCDCONSUMIDOR'=> 'T',
    			'P_CDTIPOCONS'=> null,
    			'P_TCDTIPOCONS'=> 'T',
		    );
		   
		$retorno = $this->RecalculoSaldoConsDebService->selecionaConsumidores($parameters, $params);   
        }
        /*Se o CDCLIENTE foi enviado pela currentRow devemos tratar os outros campos cada um individualmente antes de enviarmos
        os parametros corretos para a query*/
        else if(isset($params['CDCLIENTE'])){
            if($params['INFORMACONS'] == 'S'){
                if(isset($params['CDTIPOCONS'])){
                    if(isset($params['CDCONSUMIDOR'])){
                        RecalculoSaldoConsDeb::startRecalc($params); 
                    }
                foreach($params['TIPOCONSCLIE'] as $codigoCliente){
                    $codigo = explode('_', $codigoCliente);
                    $CLIENTE    = $codigo[0];
                    $TIPOCONS = $codigo[1];
                    $parameters = array(
            			'P_CDCLIENTE' => $CLIENTE,
            			'P_TCDCLIENTE' => 'T',
            			'P_CDCONSUMIDOR'=> null,
            			'P_TCDCONSUMIDOR'=> 'T',
            			'P_CDTIPOCONS'=> $TIPOCONS,
            			'P_TCDTIPOCONS'=> 'T',
        		    );
        		    $retorno = $this->RecalculoSaldoConsDebService->selecionaConsumidores($parameters, $params);   
                    }   
                }
            }
            if(isset($params['CDCONSUMIDOR'])){
                RecalculoSaldoConsDeb::startRecalc($params);
            }
            if($params['INFORMACONS'] == 'N'){
            foreach ($params['CDCLIENTE'] as $cliente){
                $CLIENTE = $cliente;
            }
            $DATAPIECES = explode('/', $params['DTRECALCULO']);
            $DATA = $DATAPIECES[2].'-'.$DATAPIECES[1].'-'.$DATAPIECES[0];
            $DATAPARAM = $params['DTRECALCULO'].' '.$params['HORAFIELD'];
            $OPERADORPARAM = $params['CDOPERADOR'];
            $FILIAL = $params['CDFILIAL'];
            $CONSUMIDOR = "";
            $retorno = $this->RecalculoSaldoConsDebService->AtualizaSaldoCons($FILIAL, $CLIENTE, $CONSUMIDOR, $DATAPARAM, $OPERADORPARAM);
                
            }
        }
    }
    
    /*Recebe os valores da currentRow ou  e repassa para o service executar a procedure,
    o foreach serve para manter associados os valores de CDCONSUMIDOR e de CDCLIENTE
    ambos vindos do campo CODIGOCONCAT presente na query*/
    public function startRecalc($params){
        $DATAPIECES = explode('/', $params['DTRECALCULO']);
        //$DATA = $DATAPIECES[2].'-'.$DATAPIECES[1].'-'.$DATAPIECES[0];
        $DATAPARAM = $params['DTRECALCULO'].' '.$params['HORAFIELD'];
        $OPERADORPARAM = $params['CDOPERADOR'];
        $FILIAL = $params['CDFILIAL'];
        foreach($params['CODIGOCONCAT'] as $cod){
            $codigos =  explode('_', $cod);
            $CLIENTE = $codigos[0];
            $CONSUMIDOR = $codigos[1];
            $retorno = $this->RecalculoSaldoConsDebService->AtualizaSaldoCons($FILIAL, $CLIENTE, $CONSUMIDOR, $DATAPARAM, $OPERADORPARAM);
            
        }
    }
  
}