<?php
namespace Teknisa\MAN\Controllers;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Services\RelTaxaDeServicoPorVendaService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Utilities;

class RelTaxaDeServicoPorVenda { 
    
    protected $relTaxaDeServicoPorVendaService;
    protected $utilService;
    protected $dataSourceManager;
              
    public function __construct (RelTaxaDeServicoPorVendaService $relTaxaDeServicoPorVendaService, Utilities\Util $utilService, Manager $dataSourceManager) {
        $this->RelTaxaDeServicoPorVendaService              = $relTaxaDeServicoPorVendaService;
        $this->utilService                                  = $utilService;
        $this->dataSourceManager                            = $dataSourceManager;
    }
    
    
     public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $result = [];
        $conditions = $this->utilService->getParamsAsArray($request);
        
        if(isset($conditions['CDFILIAL']) && !empty($conditions['CDFILIAL'])){
            
            $conditions = $this->conditionsMake($conditions);
            $result = $this->RelTaxaDeServicoPorVendaService->find( $conditions['CDFILIAL'],$conditions['TCDFILIAL'], $conditions['CDLOJA'], $conditions['TCDLOJA'], $conditions['DTABERCAIX'], $conditions['TDTABERCAIX'], $conditions['DATAINI'], $conditions['DATAFIN'], $conditions['CDVENDEDOR'], $conditions['TCDVENDEDOR']);
            $response->addDataSet(new DataSet("relTaxaDeServicoPorVenda", $result));
        }
        
        return $result;
    }
    
    public function conditionsMake($conditions){
        
        if (isset($conditions['CDFILIAL'])){
                
            if(is_array($conditions['CDFILIAL'])){
                $conditions['TCDFILIAL'] = 'F';
                $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            }
            else {
                $conditions['CDFILIAL'] = null;
                $conditions['TCDFILIAL'] = 'T';
            }
            
        } else {
            $conditions['CDFILIAL'] = null;
            $conditions['TCDFILIAL'] = 'T';
        }
        
        if (isset($conditions['CDLOJA'])){
            if(is_array($conditions['CDLOJA'])){
                $conditions['TCDLOJA'] = 'F';
                $conditions['CDLOJA'] = implode('_', $conditions['CDLOJA']);
            }
            else {
                $conditions['CDLOJA'] = null;
                $conditions['TCDLOJA'] = 'T';
            }
            
        } else {
            $conditions['CDLOJA'] = null;
            $conditions['TCDLOJA'] = 'T';
        }
        
        
        if (isset($conditions['DTABERCAIX'])){
            
            if(is_array($conditions['DTABERCAIX'])){
                $conditions['TDTABERCAIX'] = 'F';
                $conditions['DTABERCAIX'] = implode('_', $conditions['DTABERCAIX']);
            }
            else {
                $conditions['DTABERCAIX'] = null;
                $conditions['TDTABERCAIX'] = 'T';
            }
            
        } else {
            $conditions['DTABERCAIX'] = null;
            $conditions['TDTABERCAIX'] = 'T';
        }
        
        if (isset($conditions['CDVENDEDOR'])){
            
            if(is_array($conditions['CDVENDEDOR'])){
                $conditions['TCDVENDEDOR'] = 'F';
                $conditions['CDVENDEDOR'] = implode('_', $conditions['CDVENDEDOR']);
            }
            else {
                $conditions['CDVENDEDOR'] = null;
                $conditions['TCDVENDEDOR'] = 'T';
            }
            
        } else {
            $conditions['CDVENDEDOR'] = null;
            $conditions['TCDVENDEDOR'] = 'T';
        }
        
        $conditions['DATAINI'] = $conditions['DTENTRVENDA'][0];
        $conditions['DATAFIN'] = $conditions['DTENTRVENDA'][1];
    
        return $conditions;
    }

}
